# Code of Conduct

`TorchMeter` is an open-source project built by developers worldwide. We're committed to fostering a **friendly, safe, and inclusive** environment for all participants. This code applies to all community spaces including but not limited to GitHub repositories, community forums, etc.

## A. Expected Behavior

We expect all community members to:
- 🤝 **Respect differences**: Engage with diverse perspectives professionally
- 🚧 **Constructive dialogue**: Maintain courtesy even in technical disagreements
- 📌 **Stay technical**: Focus discussions on code quality and project vision
- 🌍 **Cultural awareness**: Consider global contexts when making suggestions
- 👥 **Newcomer-friendly**: Help new contributors understand community norms

## B. Unacceptable Behavior

- ⚠️ Threats of violence or inflammatory remarks
- 🔞 Sexualized content/inappropriate humor
- 🚫 Harassment
- 🎭 Discriminatory speech (race/gender/religion/etc.)
- 💢 Deliberate trolling or demeaning comments
- 📢 Spreading misinformation
- 🕵️ Privacy violations (doxxing)

## C. Enforcement

Maintainers reserve rights to:
- Remove offending content
- Temporarily/permanently ban participation
- Report to third parties (GitHub/legal authorities)
- Revise this code as community evolves

## D. Reporting

To report violations:
- ⚠️ GitHub Issue / Discussion (tag with `CoC Violation` and `@maintainers`)

Include in reports:
- Time/location of incident
- Parties involved
- Description with evidence (screenshots/logs)

## E. Scope

This code applies to:
- Project repositories (PRs/Issues/Discussions)
- Official social platforms

---

> 📜 Adapted from [Contributor Covenant 2.1](https://www.contributor-covenant.org/version/2/1/code_of_conduct/)  